/* Simple example of input validator for simple polygons.
 *
 * Checks that input is a simple polygon given in cw order.
 *
 * Does not check input bounds.
 * Does not check input format.
 */
#include <iostream>
#include "simple_polygon.h"

typedef long long coord_type;

int main(void) {
  int n;
  std::cin >> n;
  polygon<coord_type> poly(n);
  for (auto &p: poly) {
      std::cin >> p.x >> p.y;
  }
  assert(simple_polygon(poly));
  assert(!ccw(poly));
  return 42;
}
