#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "m": 10,
    "twos": 10,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    m = int(cmdlinearg("m"))
    twos = int(cmdlinearg("twos"))
    
    overlaps = set(random.sample(range(0, n*m), twos))
    print(n, m)
    for i in range(0, n):
        line = []
        for j in range(0, m):
            if i*m + j in overlaps:
                line.append('2')
            else:
                line.append('1')
        print("".join(line))


if __name__ == "__main__":
    main()